1#!/bin/sh
2#	$NetBSD: checkver,v 1.12 2000/07/22 16:04:57 erh Exp $
3#
4# Copyright (c) 1998 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Eric Haszlakiewicz.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18#
19# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29# POSSIBILITY OF SUCH DAMAGE.
30#
31
32#--------------------------------------------------------------------#
33# checkver - 
34#	Check for libraries that appear to be newer than the
35#	one we're about to install.
36#
37# checkver [-q] [-v shlib_version_file] -d [installedlibdir [library name]]"
38# checkver [-q] [-v shlib_version_file] -s [setlistdir [library name]]"
39# checkver [-q] [-v shlib_version_file] -f liblistfile [library name]"
40#
41# One of -d, -s or -f must be specified.
42#
43# all: If library name is not specified it is assumed to
44#	be the name of the current directory.
45#
46# -d: Checks the version against the installed libraries.
47#	If no further arguments are given "/usr/lib" is
48#	used as the location of installed libraries.
49#
50# -s: Checks the version against the sets.  If no argument
51#	follows the sets directory defaults to "/usr/src/distrib/sets/lists".
52#	The directory may be specified as either the top of the
53#	source tree or as the lists directory.
54#
55# -f: Checks the version against the provided list.  A filename
56#	must be supplied.
57#
58# -v: Specify the filename of the shlib_version file.  Defaults
59#     to "./shlib_version".
60#
61# This script produces no output if all library version are not
62# large than the source version.  If an installed library with a
63# version greater than the source is found, checkver prints a
64# header and a list of the names of the offending installed libraries.
65#
66# The header may be supressed by passing "-q" as the first argument.
67#
68
69TMP=/tmp/checkver.$$
70# Can't trap 11 (SEGV) in the Real Bourne Shell, since it uses it for
71# internal malloc!
72trap "exit 2" 1 2 3 4 5 6 7 8 10 12 13 14 15
73trap "[ -d $TMP ] && rm -rf $TMP" 0
74
75Usage() {
76    echo "Usage: $1 [-q] [-v version_file] -d [installedlibdir [library name]]"
77    echo "       $1 [-q] [-v version_file] -s [setlistdir [library name]]"
78    echo "       $1 [-q] [-v version_file] -f liblistfile [library name]"
79    echo "	$1 is a script that looks for installed libraries with"
80    echo "	   versions greater than that in the version file."
81    echo "	For more information, read the comments."
82}
83
84basedir=/usr/src
85setsdir=$basedir/distrib/sets/lists
86libdir=/usr/lib
87shlib_version=./shlib_version
88
89error=0
90quiet=0
91usedir=0
92usefile=0
93usesets=0
94CWD=`pwd`
95args=`getopt "df:shqv:" "$@"`
96if [ $? -ne 0 ] ; then
97    Usage $0
98    exit 0
99fi
100
101set -- $args
102
103while [ ! -z "$1" ]; do
104    case "$1" in
105	-d) usedir=1 ; shift
106	    if [ $usefile -eq 1 -o $usesets -eq 1 ]; then
107		Usage $0 ; exit 2
108	    fi;;
109	-f) usefile=1 ; arg1=$2 ; shift ; shift
110	    if [ $usedir -eq 1 -o $usesets -eq 1 ]; then
111		Usage $0 ; exit 2
112	    fi;;
113	-s) usesets=1 ; shift
114	    if [ $usedir -eq 1 -o $usefile -eq 1 ]; then
115		Usage $0 ; exit 2
116	    fi;;
117	-v) shlib_version=$2; shift ; shift ;;
118	-h) Usage $0 ; exit 0;;
119	-q) quiet=1 ; shift;;
120	--) shift ; break;;
121    esac
122done
123
124if [ $usedir -eq 0 -a $usefile -eq 0 -a $usesets -eq 0 ] ; then
125    Usage $0 ; exit 2
126fi
127
128if [ $usefile -eq 1 ] ; then
129   LIBLIST="$arg1"
130else
131   mkdir -m 0700 $TMP
132   if [ $?  != 0 ]; then
133	echo "$0: Unable to create temp directory."
134	exit 2
135   fi
136   LIBLIST=$TMP/libs.lst
137fi
138
139# Build list from the installed libraries.
140if [ $usedir -eq 1 ] ; then
141    if [ "X$1" != "X" ] ; then
142	libdir="$1"
143    fi
144    for f in $libdir ; do
145	ls $f/lib*.so.*.*
146    done > $LIBLIST 2> /dev/null
147fi
148
149# Build list from set lists.  Parameter may be either
150# the "lists" directory or the top of the source tree.
151if [ $usesets -eq 1 ] ; then
152    if [ "X$1" != "X" ] ; then
153	setsdir="$1"
154	if [ -d "$setsdir/distrib/sets/lists" ] ; then
155	    setsdir="$setsdir/distrib/sets/lists"
156	fi
157    fi
158    (cd $setsdir ;
159     cat */[a-z]* | grep '^./usr/lib/lib.*\.so\.[0-9][0-9]*\.[0-9][0-9]*' \
160		  | sort -u > $LIBLIST
161    )
162fi
163
164#
165# The file $LIBLIST now contains a list of libraries.
166#
167
168if [ "X$2" = "X" ] ; then
169    makefile=$CWD/Makefile
170    libname=`grep '^LIB=' $makefile | sed -e 's/^LIB=[[:space:]]*//'`
171
172    # Assume the library name is the name of the current directory.
173    if [ -z $libname ]; then
174	libname=`basename $CWD`
175    fi
176else
177    libname="$2"
178fi
179echo $libname | grep "^lib" 1>&2 2> /dev/null
180if [ $? != 0 ]; then
181    libname="lib$libname"
182fi
183
184
185if [ ! -f $shlib_version ] ; then
186    echo "$0: unable to find $shlib_version"
187    exit 2
188fi
189
190# Grab major and minor numbers from the source.
191. $shlib_version
192
193if [ "X$minor" = "X" -o "X$major" = "X" ] ; then
194    echo "$0: $shlib_version doesn't contain the version."
195    exit 2
196fi
197
198# Find every shared object library with the same base name.
199 for instlib in `grep $libname.so "$LIBLIST" ` ; do
200    # Grab the major and minor from the installed library.
201    instmajor=`basename $instlib | awk 'BEGIN { FS="." } { print $3 } '`
202    instminor=`basename $instlib | awk 'BEGIN { FS="." } { print $4 } '`
203    instteeny=`basename $instlib | awk 'BEGIN { FS="." } { print $5 + 0 } '`
204
205    # If they're greater than the source, complain.
206    if [ "0$major" -eq "0$instmajor" ] ; then
207	if [ "0$minor" -eq "0$instminor" ] ; then
208	    if [ "0$teeny" -lt "0$instteeny" ] ; then
209		if [ $error -eq 0 -a $quiet -eq 0 ]; then
210		    echo -n "The following libraries have versions greater"
211		    echo " than the source:"
212	        fi
213		echo $instlib > /dev/stderr
214		error=1
215	    fi
216        elif [ "0$minor" -lt "0$instminor" ] ; then
217	    if [ $error -eq 0 -a $quiet -eq 0 ]; then
218		echo -n "The following libraries have versions greater"
219		echo " than the source:"
220	    fi
221	    echo $instlib > /dev/stderr
222	    error=1
223	fi
224    elif [ "0$major" -lt "0$instmajor" ] ; then
225	if [ $error -eq 0 -a $quiet -eq 0 ] ; then
226	    echo -n "The following libraries have versions greater"
227	    echo " than the source:"
228	fi
229	echo $instlib > /dev/stderr
230	error=1
231    fi
232 done
233
234exit $error
235